#include <stdio.h>
#include <string.h>
#include "ggi_widget.h"


ggi_widget_bitmap_t ggiWidgetBitmapAllocate(int x,int y) {

	int w=(x+7)/8;
	ggi_widget_bitmap_t rc;
	
	if (NULL==(rc=malloc(sizeof(*rc)))) return NULL;
	if (NULL==(rc->data=malloc(w*y*sizeof(rc->data[0])))) {
		free(rc);
		return NULL;
	}
	memset(rc->data,0,w*y*sizeof(rc->data[0]));
	rc->size.x=x;rc->size.y=y;
	return rc;
}

int ggiWidgetBitmapFree(ggi_widget_bitmap_t bitmap) {

	if (!bitmap) return 1;
	free(bitmap->data);
	free(bitmap);
	return 0;
}

static char *ggiWidgetFgetsNocomment(char *buffer,int size, FILE *fd) {

	char *rc;
	while((rc=fgets(buffer,size,fd)))
		if (*rc!='#') break;
	return rc;
}

ggi_widget_bitmap_t ggiWidgetBitmapLoadPBM(char *file) {

	FILE *fd;
	ggi_widget_bitmap_t rc;
	char buffer[1024];
	int x,y;
	
	rc=NULL;
	if (NULL==(fd=fopen(file,"r"))) return NULL;
	
	if (!ggiWidgetFgetsNocomment(buffer,sizeof(buffer),fd)) 
		goto closeout;
	if (strcmp(buffer,"P4\n"))
		goto closeout;

	if (!ggiWidgetFgetsNocomment(buffer,sizeof(buffer),fd)) 
		goto closeout;
	if (2!=sscanf(buffer,"%d %d",&x,&y)||x<=0||y<=0)
		goto closeout;
	rc=ggiWidgetBitmapAllocate(x,y);
	if (!rc) goto closeout;

	fread(rc->data,1,(x+7)/8*y,fd);
	
	closeout:
	fclose(fd);
	return rc;
}

void ggiWidgetBitmapPlot(ggi_widget_bitmap_t  bitmap,ggi_visual_t vis,int x,int y) {

	int xx,yy,w;

	static unsigned char bits[8]={128,64,32,16,8,4,2,1};
	
	w=(bitmap->size.x+7)/8;

	if (!bitmap) return;
	for(yy=0;yy<bitmap->size.y;yy++) {
		for(xx=0;xx<bitmap->size.x;xx++) {
			if (bitmap->data[yy*w+xx/8]&bits[xx&7])
				ggiDrawPixel(vis,x+xx,y+yy);
		}
	}
}

void ggiWidgetBitmapPlotOpaque(ggi_widget_bitmap_t  bitmap,ggi_visual_t vis,int x,int y) {

	int xx,yy,w;
	ggi_pixel fg,bg;

	static unsigned char bits[8]={128,64,32,16,8,4,2,1};
	
	w=(bitmap->size.x+7)/8;

	if (!bitmap) return;
	ggiGetGCForeground(vis,&fg);
	ggiGetGCBackground(vis,&bg);

	for(yy=0;yy<bitmap->size.y;yy++) {
		for(xx=0;xx<bitmap->size.x;xx++) {
			ggiPutPixel(vis,x+xx,y+yy,(bitmap->data[yy*w+xx/8]&bits[xx&7])?fg:bg);
		}
	}
}
